<template>
  <div>
    <q-card>
      <q-card-actions>
        <q-btn type="a" label="Kembali" to="/produk/saya" color="orange" icon="arrow_left" />
      </q-card-actions>
      <q-card-section>
        <q-item-label class="text-h5">Pilih Gambar</q-item-label>
      </q-card-section>
      <q-card-section>
        <q-card style="max-width: 400px">
          <q-card-section>
            Main Image
          </q-card-section>
          <q-card-section>
            <q-file label-color="green" counter outlined label="Main Image" v-model="main_image" use-chips ref="mainImage"
                    @input="mainImageUrlChange"
                    accept="image/*" @clear="mainImageUrlChange">
              <template v-slot:prepend>
                <q-icon name="attach_file" />
              </template>
            </q-file>
          </q-card-section>
          <q-card-section>
            <q-img :src="mainImageUrl" v-if="mainImageUrl" >
              <div class="absolute-bottom-right text-subtitle2">
                <q-btn icon="delete" color="red" @click="deleteMainImage" />
              </div>
            </q-img>
          </q-card-section>
        </q-card>
      </q-card-section>
      <q-separator />
      <q-card-actions>
        <q-btn icon="add" label="Add" color="green" @click="jmlImage = jmlImage + 1" />
      </q-card-actions>
      <q-card-section>
        <div class="fit row wrap justify-start items-start content-start q-gutter-md">
          <div class="" style="width: 300px; max-width: 400px" v-for="(imageProduct, index) in imageUrl" v-bind:key="index">
            <q-img :src="imageProduct">
              <div class="absolute-bottom-right text-subtitle2">
                <q-btn icon="delete" color="red" @click="deleteImageProduct(index)" />
              </div>
            </q-img>
          </div>
        </div>
      </q-card-section>
      <q-card-section>
        <div class="fit row wrap justify-start items-start content-start q-gutter-md">
          <q-card class="col" style=" min-width: 300px; max-width: 400px;" v-for="(jml, index) in jmlImage" v-bind:key="index" >
            <q-card-section>
              <ProductImage @addImage="addImage" @deleteImage="deleteImage" />
            </q-card-section>
          </q-card>
        </div>
      </q-card-section>
      <q-separator />
      <q-card-actions align="right">
        <q-btn @click="submitFile" label="Selanjutnya" icon="arrow_right" color="green" v-if="(image.length || imageUrl.length) && mainImageUrl" />
      </q-card-actions>
    </q-card>
  </div>
</template>

<script>
import ProductImage from 'components/Product/Image'
import {axiosInstance} from "boot/axios";
export default {
  name: 'Step1Product',
  components: {
    ProductImage
  },
  data () {
    return {
      product: null,
      main_image: null,
      mainImageUrl: null,
      jmlImage: 1,
      image: [],
      imageUrl:  [],
    }
  },
  mounted() {
    this.getProductDraft()
  },
  methods: {
    getProductDraft() {
      this.$q.loading.show()
      this.$axios.post("api/product/draft")
        .then(sukses => {
          this.product = sukses.data
          this.imageUrl =  (this.product) ? this.product.image : [];
          this.mainImageUrl = (this.product) ? this.product.main_image : null;
          if (this.product.main_image != "") {
            this.$q.notify({
              message: "Anda Melanjutkan Produk Sebelumnya",
              color: "orange",
              position: "top"
            })
          }
          this.$q.loading.hide()
        })
      .catch(error => {
        this.$q.loading.hide()
        this.$router.back()
      })
    },
    addImage(val) {
      this.image.push(val)
      window.scrollTo(0,10000);
    },
    deleteImage(val) {
      this.image.splice(this.image.indexOf(val), 1);
    },
    deleteAllImage() {
      this.jmlImage = 1;
      this.image.splice(1, this.image.length - 1);
    },
    submitFile() {
      if ((this.image.length || this.imageUrl.length) && this.mainImageUrl) {
        let file = {
          main_image: this.main_image,
          image: this.image,
          image_url: this.imageUrl
        }
        let data = new FormData();
        data.append("main_image", file.main_image)
        if (this.image.length) {
          for (let gambar in file.image) {
            data.append("image[]", file.image[gambar]);
          }
        }
        if (this.imageUrl.length) {
          for (let imageProduct in this.imageUrl) {
            data.append("image_url[]", this.imageUrl[imageProduct])
          }
        }
        this.$q.loading.show()
        this.$axios.post("api/product/image", data)
        .then(sukses => {
          this.$q.loading.hide()
          this.$emit("nextStep", sukses.data)
        })
        .catch(error => {
          this.$q.loading.hide()
          window.location.reload()
          this.$q.notify({
            message: "Mohon Maaf Ada Kesalahan",
          })
        })
      } else {
        this.$q.notify({
          message: "Mohon Tambahkan File",
          color: "red",
          position: "top"
        })
      }
    },
    mainImageUrlChange(val) {
      if (val) {
        this.mainImageUrl = URL.createObjectURL(val);
      } else {
        this.mainImageUrl = null;
      }
    },
    deleteMainImage() {
      this.$refs.mainImage.removeAtIndex(0);
    },
    deleteImageProduct(index) {
      this.imageUrl.splice(index, 1)
    }
  }
}
</script>
